#include<bits/stdc++.h>
using namespace std;
int main(){
    int t;
    cin>>t;
    int n;
    for(int i=0;i<t;i++){
        cin>>n;
        int a[n];  int b[n];
        int br1=0; int br2=0;
        int achos; int bchos;
        int poza;  int pozb;
        for(int i=0;i<n;i++){
            cin>>a[i];
            if(a[i]!=0){
                br1++;
                achos=a[i];
                poza=a[i];
            }
        }
        for(int i=0;i<n;i++){
            cin>>b[i];
            if(b[i]!=0){
                br2++;
                bchos=b[i];
                pozb=b[i];
            }
        }
        if(br1==1 && br2==1){
            if(achos==bchos){
                if((poza-pozb)%2==0) cout<<"DA"<<endl;
                if((poza-pozb)%2==1) cout<<"NE"<<endl;
            } else {
                if(achos==-bchos){
                    if((poza-pozb)%2==0) cout<<"NE"<<endl;
                    if((poza-pozb)%2==1) cout<<"DA"<<endl;
                } else {
                    cout<<"NE"<<endl;
                }
            }
        }
    }
}